//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "calc.h"
#include "about.h"
#include "flutppc.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TfrmBNC *frmBNC;

#define DELIMITADOR 1
#define VARIAVEL 2
#define NUMERO 3

char *prog, *scratch;  /* contains expression to be evaluated */
char token[80];
char tok_type;
int entryid=1L;

Ereal vars[26];

void eval_exp(Ereal *answer), eval_exp2(Ereal *answer);
void eval_exp1(Ereal *answer);
void eval_exp3(Ereal *answer), eval_exp4(Ereal *answer);
void eval_exp5(Ereal *answer);
void eval_exp6(Ereal *answer), atom(Ereal *answer);
void get_token(void), putback(void);
void unary(char o, Ereal *r);
void serror(int error);
Ereal find_var(char *s);
int isdelim(char c);

/* Evaluator entry point */
void eval_exp(Ereal *answer)
{
 get_token();
 if(!*token) {
  serror(2);
  return;
 }
 eval_exp1(answer);
}

/* Processes a variable attribution */
void eval_exp1(Ereal *answer)
{
 int slot;
 char ttok_type;
 char *temp_token=new char[80];

 if(tok_type==VARIAVEL) {
  /* save old token */
  strcpy(temp_token,token);
  ttok_type = tok_type;

  /* calculates index of variable */
  slot = toupper(*token)-'A';

  get_token();
  if(*token != '=') {
  putback(); /* puts back next token */
  /* restores old token - no attribution */
  strcpy(token,temp_token);
  tok_type = ttok_type;
 }
 else {
  get_token(); /* get next token */
  eval_exp2(answer);
  vars[slot] = *answer;
  delete[] temp_token;
  return;
 }
}
 eval_exp2(answer);
 delete[] temp_token;
}

/* Sums or subtracts two factors */
void eval_exp2(Ereal *answer)
{
 register char op;
 Ereal *temp=new Ereal;

 eval_exp3(answer);
 while((op = *token) == '+' || op == '-') {
  get_token();
  eval_exp3(temp);
  switch(op) {
   case '-':
    *answer = *answer - *temp;
    break;
   case '+':
    *answer = *answer + *temp;
    break;
  }
 }
 delete temp;
}

/* Multiplies or divides two factors */
void eval_exp3(Ereal *answer)
{
 register char op;
 Ereal *temp=new Ereal;

 eval_exp4(answer);
 while((op = *token)=='*' || op=='/' || op=='%') {
  get_token();
  eval_exp4(temp);
  switch(op) {
   case '*':
    *answer = *answer * *temp;
    break;
   case '/':
    *answer = *answer / *temp;
    break;
  }
 }
 delete temp;
}

/* Processes an exponent */
void eval_exp4(Ereal *answer)
{
 Ereal temp, abtemp, ex, t;
// register int t;

 eval_exp5(answer);
 if(*token=='^') {
  get_token();
  eval_exp4(&temp);
  ex = *answer;
  if(temp==zero) {
   *answer = um;
   return;
  }
//  for(t=dbl(absol(*temp))-1;t>0;--t) *answer = (*answer) * *ex;
  abtemp=inteiro(absol(temp));
  for(t=abtemp-um;t>=um;t-=um)
     *answer = (*answer) * ex;
  if(temp<zero)
    *answer = um / *answer;
 }
}

/* Processes an unary + or - or a factorial  */
void eval_exp5(Ereal *answer)
{
 char op;
 int n=0;
 Ereal r_32766("32766");

 op = 0;
 if((tok_type == DELIMITADOR) && *token=='+' ||
     *token=='-' || *token=='!') {
  op = *token;
  get_token();
 }
 eval_exp6(answer);
 if(op=='-') *answer = -(*answer);
 else if(op=='!') {
   if (*answer>=zero && *answer<=r_32766)
     n = eint(*answer); // ATENCAO !!! problemas de precisao double->int!
   else if (*answer<zero)
     n = -1;
   else throw TMathError("! out of range.");
   *answer = fatorial(n);
 }
}

/* Processes an expression between parenthesis */
void eval_exp6(Ereal *answer)
{
 if((*token=='(')) {
  get_token();
  eval_exp2(answer);
  if(*token!=')')
   serror(1);
  get_token();
 }
 else
  atom(answer);
}

void atom(Ereal *answer)
{
 switch(tok_type) {
  case VARIAVEL:
   *answer = find_var(token);
   get_token();
   return;
  case NUMERO:
   *answer = r(token);
   get_token();
   return;
  default:
   serror(0);
 }
}

/* Puts back a token into the input stream */
void putback(void)
{
 char *t;

 t = token;
 for(;*t;t++) prog--;
}

/* raises an evaluation exception */
void serror(int error)
{
 static char *e[] = {
    "Syntax error",
    "Missing parenthesis",
    "No expression"
  };
  throw TMathError(e[error]);
}

/* Gets next token */
void get_token(void)
{
 char *temp;

 tok_type = 0;
 temp = token;
 *temp = '\0';

 if(!*prog) return; /* end of expression */
 while(isspace(*prog)) ++prog; /* ignore whitespaces */

 if(strchr("!+-*/%^=()",*prog)) {
  tok_type = DELIMITADOR;
  /* advance to next char */
  *temp++ = *prog++;
 }
 else if(isalpha(*prog)) {
  while(!isdelim(*prog)) *temp++ = *prog++;
  tok_type = VARIAVEL;
 }
 else if(isdigit(*prog)) {
  while(!isdelim(*prog)) *temp++ = *prog++;
  tok_type = NUMERO;
 }

 *temp = '\0';
}

/* Returns true if c is a delimiter */
isdelim(char c)
{
 if(strchr("?!+-/*%^=() ",c) || c==9 || c=='\r' || c==0)
  return 1;
 return 0;
}

Ereal find_var(char *s) {
 if(!isalpha(*s)) {
  serror(1);
  return zero;
 }
 return vars[toupper(*token)-'A'];
}

//---------------------------------------------------------------------------
__fastcall TfrmBNC::TfrmBNC(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::btnEvaluateClick(TObject *Sender)
{
Ereal answer;
char *buffer;

buffer = new char[max+15];
prog = scratch;

strcpy(prog,meWorkspace->SelText.c_str());

try {

  StatusBar->SimpleText = "Calculating ...";
  StatusBar->Refresh();

  eval_exp(&answer);

  StatusBar->SimpleText = "Ready ...";
  StatusBar->Refresh();

  meWorkspace->Lines->Add("Out["+AnsiString(int(entryid++))+"] = "+texto(answer,buffer));
  meWorkspace->Lines->Add("");
}
catch (TMathError &Erro) {

  StatusBar->SimpleText = "Error ...";
  StatusBar->Refresh();

  Application->MessageBox(Erro.Message.c_str(),"Error",MB_OK);

  meWorkspace->Lines->Add("Out["+AnsiString(int(entryid++))+"] = "+Erro.Message);
  meWorkspace->Lines->Add("");
}

delete [] buffer;
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::FormCreate(TObject *Sender)
{
scratch = new char[256];
Bevel1->Width = ClientWidth;
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::FormDestroy(TObject *Sender)
{
delete [] scratch;
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::SpeedButton1Click(TObject *Sender)
{
meWorkspace->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::mnExitClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::mnEvaluateClick(TObject *Sender)
{
btnEvaluate->Click();
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::mnOpenClick(TObject *Sender)
{
Ereal answer;
char *buffer;
FILE *in;

buffer = new char[max+15];

OpenDialog1->Filter = "*.scr";
OpenDialog1->FileName = "*.scr";

if (OpenDialog1->Execute()) {
  in = fopen(OpenDialog1->FileName.c_str(),"rt");
  if (in) {
    while (!feof(in)) {

      prog = scratch;
      fscanf(in,"%s",prog);

      try {

        meWorkspace->Lines->Add(prog);

        StatusBar->SimpleText = "Calculating ...";
        StatusBar->Refresh();

        eval_exp(&answer);

        Application->ProcessMessages();

        StatusBar->SimpleText = "Ready ...";
        StatusBar->Refresh();

        meWorkspace->Lines->Add("Out["+AnsiString(int(entryid++))+"] = "+texto(answer,buffer));
      }
      catch (TMathError &Erro) {

        StatusBar->SimpleText = "Error ...";
        StatusBar->Refresh();

        meWorkspace->Lines->Add("Out["+AnsiString(int(entryid++))+"] = "+Erro.Message);
      }
    }
  }
  else
    Application->MessageBox("Error reading file.","Error",MB_OK);

delete [] buffer;
}
//
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::SpeedButton2Click(TObject *Sender)
{
mnOpenClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::SpeedButton3Click(TObject *Sender)
{
Close();	
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::FormResize(TObject *Sender)
{
Bevel1->Width = ClientWidth;	
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::SpeedButton4Click(TObject *Sender)
{
SaveDialog1->Filter = "*.lst";
SaveDialog1->FileName = "*.lst";

if (SaveDialog1->Execute()) {
  meWorkspace->Lines->SaveToFile(SaveDialog1->FileName);
}
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::mnSaveClick(TObject *Sender)
{
SpeedButton4->Click();	
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::mnExit1Click(TObject *Sender)
{
Close();	
}
//---------------------------------------------------------------------------
void __fastcall TfrmBNC::aboutClick(TObject *Sender)
{
frmAbout->ShowModal();	
}
//---------------------------------------------------------------------------
